// Data: 21/07/2021
// Prof. Dr. Jean M. Simo

//UNIVERSIDADE TECNOLGICA FEDERAL DO PARAN - Campus de Curitiba
//(Brasil) - Departamento Acadmico de Informtica (DAINF).

//Disciplina: Tcnicas de Programao

#include <cstdlib>
#include <cstddef>

#include <iostream>
#include <vector>
using namespace std;

#define NUM_ITERACOES 100

// (Questo - 1)

class Ente
{
      protected:
              int massa;

      public:
              Ente():
                  massa (-1)
              {
              }

              virtual ~Ente() { massa = -1; }

              void setMassa(const int m){ massa = m; }
              const int getMassa() const { return massa; }

              void operator++() { massa++; }
              virtual void operator--() { massa--; }
};

/* (Questo - 2) */

class Constelacao : public Ente
{
  private:
          int distancia_buraco;

  public:
          Constelacao():
              Ente(),
              distancia_buraco(-1)
          {

          }
          ~Constelacao()
          {
            distancia_buraco = -1;
            // cout << "Destrutora Constelacao." << endl; getchar();
          }

          void setDistaciaBuraco(const int DB) { distancia_buraco = DB; }
          int getDistanciaBuraco() const { return distancia_buraco ; }

          void operator--() { distancia_buraco--; }
};


// (Questo - 3)

class ZonaGravitacional
{
  private:
          vector<Ente*> vet;

  public:
         ZonaGravitacional():
            vet()
         {
              //cout << "Construtora de ZonaGravitacional." << endl; getchar();
         }

         ~ZonaGravitacional()
         {
             // cout << "Destrutora de ZonaGravitacional." << endl; getchar();

             for (int i = 0; i < getTamanho(); i++)
             {
                 if (vet[i] != NULL)
                 {
                     delete vet[i];
                     vet[i] = NULL;
                 }
             }
             vet.clear();
         }

         void incluir(Ente* P)     // Mtodo para incluir uma Nave.
         {
                if (NULL != P)
                {
                    vet.push_back(P);
                }
                else
                {
                    cout << "Ponteiro de Ente nulo" << endl;
                }
         }


         Ente* retornar(const int pos) const
         {
               if ( (pos>=0) && (pos < getTamanho()) )
               {
                   return vet[pos];
               }
               else
               {
                   cout << "Posicao invlida para retorno." << endl;
                   return NULL;
               }
         }

         const int getTamanho() const
         {
             return (int) vet.size();
         }

         void eliminar(const int pos)
         {
             if ( (pos>=0) && (pos < getTamanho()) )
             {
                Ente* p = vet[pos];
                vet[pos] = NULL;
                delete p;
                p = NULL;
             }
             else
             {
                 cout << "Posicao invlida para eliminao." << endl;
             }
         }

};

// (Questo - 4)

class BuracoGravitacional : public Ente   //Derivado da classe Nave.
{
  private:
          ZonaGravitacional GC, GB;

  public:
          BuracoGravitacional():
              Ente(),
              GC(),
              GB()
          {
                // cout << "Construtora de BuracoGravitacional." << endl; getchar();
          }

          ~BuracoGravitacional()
          {
                cout << "Destrutora de BuracoGravitacional." << endl; getchar();
          }

          void operator= (BuracoGravitacional* pBG)
          {
              if (pBG != NULL)
              {
                  GB.incluir(static_cast<Ente*>(pBG));

                  //cout << "Buraco Gravitacional incluido!" << endl; //getchar();
              }
              else
              {
                  cout << "Ponteiro de BuracoGravitacional (pBG) nulo." << endl;
              }
          }

          void operator= (Constelacao* pC)
          {
              if (pC != NULL)
              {
                  Ente* p = static_cast<Ente*>(pC);
                  GC.incluir(p);

                  //pC = (Constelacao*)p;
                  //pC = static_cast<Constelacao*>(p);

                  //cout << "Distancia constelacao: " << pC->getDistanciaBuraco() << endl; getchar();
              }
              else
              {
                  cout << "Ponteiro de Constelacao (pC) nulo." << endl;
              }
          }

          void executar()
          {
              BuracoGravitacional*  pBG = NULL;
              Constelacao*          pC  = NULL;

              int cont = 0;

              for (int i = 0; i < NUM_ITERACOES; i++)
              {
                  cout << "Tamanho Grupo Constelaes: " << GC.getTamanho() << endl;

                  cont = 0;

                  for (int j = 0; j < GC.getTamanho(); j++)
                  {
                      pC = static_cast<Constelacao*>(GC.retornar(j));

                      if (pC != NULL)
                      {
                            pC->operator--();


                            if ( pC->getDistanciaBuraco() <= 0 )
                            {
                                cout << "Distancia constelacao: " << pC->getDistanciaBuraco() << endl;
                                cout << "Constelao sendo consumida :" << pC->getMassa() << endl; //getchar();
                                setMassa( getMassa() + pC->getMassa() );
                                GC.eliminar(j);
                            }
                            else
                            {
                                //cout << "Distancia constelacao: " << pC->getDistanciaBuraco() << endl;
                                //cout << "Constelao NAO sendo consumida :" << pC->getMassa() << endl; //getchar();
                            }
                      }
                      else
                      {
                          cont++;
                      }

                  }

                  cout << "Quantidade de contelacoes consumidas: " << cont << endl; //getchar();

                  cout << endl;

                  cont = 0;
                  for (int j = 0; j < GB.getTamanho(); j++)
                  {
                      //pBG = (BuracoGravitacional*) GB.retornar(j);
                      pBG = static_cast<BuracoGravitacional*>(GB.retornar(j));

                      if (pBG)
                      {
                            if ( pBG->getMassa() < getMassa() )
                            {
                                pBG->operator--();
                                //(*pBG).operator--();

                                operator++();
                            }

                            if ( pBG->getMassa() <= ( getMassa()/2 ) )
                            {
                                cout << "Buraco gravitacional sendo consumido: " << pBG->getMassa() << endl; //getchar();
                                setMassa( getMassa() + pBG->getMassa() );
                                GB.eliminar(j);
                            }
                            else
                            {
                                //cout << "Buraco gravitacional NAO sendo consumido: " << pBG->getMassa() << endl; // getchar();
                            }
                      }
                      else
                      {
                          cont++;
                      }
                  }

                  cout << "Quantidade de buracos consumidos: " << cont << endl; // getchar();

                  cout << endl;
              }
          }
};

// (Questo - 5)

class Galaxia
{
  private:
           ZonaGravitacional    GZ;

           Constelacao          *pAuxC;

           BuracoGravitacional  *pMaior, *pMedio, *pMenor;

  public:
           Galaxia():
           GZ(),
           pAuxC(NULL),
           pMaior(NULL),
           pMedio(NULL),
           pMenor(NULL)
           {
                //cout << "Construtora de Galaxia." << endl; getchar();

                criarBuracosGravitacionais();
                criarConstelacoes();
                executar();

           }
           ~Galaxia()
           {
               // cout << "Destrutora de Galaxia." << endl; getchar();
               if (pMaior) delete pMaior;
               if (pMedio) delete pMedio;
               if (pMenor) delete pMenor;
           }

           void criarBuracosGravitacionais()
           {
			   pMaior = new BuracoGravitacional();
			   pMedio = new BuracoGravitacional();
			   pMenor = new BuracoGravitacional();

			   pMaior->setMassa(100);
			   pMedio->setMassa(50);
			   pMenor->setMassa(5);

			   pMaior->operator=(pMedio);
			   pMaior->operator=(pMenor);
           }

           void criarConstelacoes()
           {
              for (int i = 0; i <100; i++)
              {
                  pAuxC = NULL;
                  pAuxC = new Constelacao();

                  pAuxC->setDistaciaBuraco(i + 1);
                  //cout << "Distancia constelacao: " << pAuxC->getDistanciaBuraco() << endl; getchar();

                  pAuxC->setMassa (10*i);


                  pMaior->operator=(pAuxC);
              }

              pAuxC = NULL;
           }

           void executar()
           {
                pMaior->executar();
           }
};

int main()
{
    Galaxia FiatLux;

    //system ( "PAUSE" );

    return 0;
}


